from struct import pack, unpack, calcsize

# START:pack
def packVec(vec):
    buf = [pack("i", len(vec))]
    for v in vec:
        buf.append(pack("i", v))
    return ''.join(buf)
# END:pack

# START:unpack
def unpackVec(buf):
    size = calcsize("i")
    num = unpack("i", buf[0:size])[0]
    pos = size
    result = []
    for i in range(num):
        v = unpack("i", buf[pos:pos+size])
        result.append(v[0])
        pos += size
    return result
# END:unpack

# START:test
if __name__ == "__main__":

    tests = [
        [],
        [1],
        [19, 27],
        [-3, 456]
    ]

    for t in tests:
        data = packVec(t)
        print repr(data)
        result = unpackVec(data)
        assert result == t
# END:test
