import sys, struct, bisect, random, cStringIO

# START:pack
FMT_HDR = "3i"
LEN_HDR = struct.calcsize(FMT_HDR)
FMT_08 = "B"
FMT_16 = "h"
FMT_32 = "i"
def save(data):
    data.sort()
    num08 = bisect.bisect_left(data, 0x01 << 8)
    num16 = bisect.bisect_left(data, 0x01 << 16)
    num32 = len(data)
    result = cStringIO.StringIO()
    result.write(struct.pack(FMT_HDR, num08, num16, num32))
    i = 0
    while i < num08:
        result.write(struct.pack(FMT_08, data[i] & 0xFF))
        i += 1
    while i < num16:
        result.write(struct.pack(FMT_16, data[i] & 0xFFFF))
        i += 1
    while i < num32:
        result.write(struct.pack(FMT_32, data[i]))
        i += 1
    return result.getvalue()
# END:pack

# START:unpack
def load(buffer):
    result = []
    num08, num16, num32 = struct.unpack(FMT_HDR, buffer[0:LEN_HDR])
    loc = LEN_HDR
    num = 0
    while num < num08:
        result.append(struct.unpack(FMT_08, buffer[loc])[0])
        loc += 1
        num += 1
    while num < num16:
        result.append(struct.unpack(FMT_16, buffer[loc:loc+2])[0])
        loc += 2
        num += 1
    while num < num32:
        result.append(struct.unpack(FMT_32, buffer[loc:loc+4])[0])
        loc += 4
        num += 1
    return result
# END:unpack

# START:test
if __name__ == "__main__":
    tests = [
        [],
        [0x00000003],
        [0x00000003, 0x00000007, 0x00000009],
        [0x00000123],
        [0x00000003, 0x00000123],
        [0x00000123, 0x00000003],
        [0x00011111],
        [0x00000003, 0x00000123, 0x00000003, 0x00011111]
    ]
    for t in tests:
        packed = save(t)
        unpacked = load(packed)
        t.sort()
        assert t == unpacked
# END:test
