from struct import pack, unpack, calcsize

# START:functions
def packVec(vec):
    buf = pack("i", len(vec))
    for v in vec:
        buf += pack("i", len(v))
        format = "%ds" % len(v)
        buf += pack(format, v)
    return buf

def unpackVec(buf):
    intSize = calcsize("i")
    num = unpack("i", buf[0:intSize])[0]
    pos = intSize
    result = []
    for i in range(num):
        length = unpack("i", buf[pos:pos+intSize])[0]
        pos += intSize
        format = "%ds" % length
        str = unpack(format, buf[pos:pos+length])[0]
        result.append(str)
        pos += length
    return result
# END:functions

if __name__ == "__main__":

    tests = [
        [],
        [""],
        ["a"],
        ["abc", "def"],
    ]

    for t in tests:
        data = packVec(t)
        print repr(data)
        result = unpackVec(data)
        assert result == t
