import sys, random

# START:keepN
def keepN(lines, N):

    # Make sure random number generation is reproducible.
    random.seed(12345213)

    # If not enough data, return what's there.
    if (not lines) or (len(lines) <= N):
        return lines[:]

    # Probability of keeping any line.
    prob = float(N) / len(lines)

    # Select.
    result = []
    for l in lines:
        if random.random() < prob:
            result.append(l)

    return result
# END:keepN

if __name__ == "__main__":
    lines = list("abcdefghijklmnopqrstuvwxyz")
    for i in (3, 5, 9):
        print keepN(lines, i)
