import re

# START:encode
Special = ("%", " ", "$", "&", "+", ",",
           "/", ":", ";", "=", "?", "@")
def encodeString(str):
    for c in Special:
        v = "%" + "%02X" % ord(c)
        str = str.replace(c, v)
    return str
def encode(baseUrl, extras):
    result = baseUrl
    sep = "?"
    for (key, value) in extras:
        key = encodeString(key)
        value = encodeString(value)
        result = result + sep + key + "=" + value
        sep = "&"
    return result
# END:encode

if __name__ == "__main__":

    tests = [
        ["http://xyz.com", []],
        ["http://xyz.com", [["a", "b"]]],
        ["http://xyz.com", [["a b", "c&d"]]]
    ]

    for (baseUrl, extras) in tests:
        print baseUrl, "and", extras, "is", encode(baseUrl, extras)

