/***
 * Excerpted from "Data Crunching"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/gwd for more book information.
***/
import java.io.*;
import java.util.regex.*;

public class AllAddresses3 {

    String Patstr = ".*?([\\w_\\.-]+@[\\w_-]+(\\.[\\w_-]+)*)(.*)";

    public static void main(String[] args) {
        try {
            Pattern patObj = Pattern.compile(Patstr);
            for (int i=0; i<args.length; ++i) {
                String filename = args[i];
                BufferedReader input = 
                    new BufferedReader(new FileReader(filename));
                String line;
                while ((line = input.readLine()) != null) {
                    while (line.length() > 0) {
                        Matcher m = patObj.matcher(line);
                        if (m.matches()) {
                            System.out.println(m.group(1));
                            line = m.group(3);
                        }
                        else {
                            break;
                        }
                    }
                }
            }
        }
        catch (FileNotFoundException e) {
            System.err.println("No such file: " + e);
        }
        catch (IOException e) {
            System.err.println("Error reading line: " + e);
        }
    }
}
