/***
 * Excerpted from "Data Crunching"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/gwd for more book information.
***/
import java.io.*;
import java.util.regex.*;

public class AllAddresses5 {

    public static void main(String[] args) {
        try {
            // START:string
            String patStr = 
                ".*?             # anything before the first address\n"
              + "(               # start of group 1\n"
              + "[\\w_\\.-]+     # user name\n"
              + "@               # literal '@'\n"
              + "[\\w_-]+        # first part of domain\n"
              + "(\\.[\\w_-]+)*  # rest of domain (group 2)\n"
              + ")               # end of group 1\n"
              + "(.*)            # rest of string (group 3)";
            Pattern patObj = Pattern.compile(patStr, Pattern.COMMENTS);
            // END:string
            for (int i=0; i<args.length; ++i) {
                String filename = args[i];
                BufferedReader input = 
                    new BufferedReader(new FileReader(filename));
                String line;
                while ((line = input.readLine()) != null) {
                    while (line.length() > 0) {
                        Matcher m = patObj.matcher(line);
                        if (m.matches()) {
                            System.out.println(m.group(1));
                            line = m.group(3);
                        }
                        else {
                            break;
                        }
                    }
                }
            }
        }
        catch (FileNotFoundException e) {
            System.err.println("No such file: " + e);
        }
        catch (IOException e) {
            System.err.println("Error reading line: " + e);
        }
    }
}
