/***
 * Excerpted from "Data Crunching"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/gwd for more book information.
***/
import java.util.regex.Pattern;
public class Pairs {
    private static final String RE[] = {
        "",      "a",      "a.b",
        "a?b",   "a*b",    "a+b",
        "a\\.b", "a\\+b",  ".*ab"
    };
    private static final String _Data[] = {
        "",    "a",     "b",
        "Xab", "aXb",   "abX",
        "ab",  "aXXXb", "a.b"
    };
    // Tidy display
    private static void show(String s) {
        if (s == null) {
	    s = "\t";
	}
	else if (s.trim().length() == 0) {
	    s = "''";
	}
	System.out.print(s);
    }
    // Results
    public static void main(String[] args) {
	show(null);
	for (int j=0; j<_Data.length; ++j) {
	    show("\t" + _Data[j]);
	}
	System.out.println();
	for (int i=0; i<RE.length; ++i) {
	    String re = RE[i];
	    show(re);
	    for (int j=0; j<_Data.length; ++j) {
		String data = _Data[j];
		boolean m = Pattern.matches(re, data);
		show(m ? "\t+" : "\t-");
	    }
	    System.out.println();
	}
    }
}
