import sys, re

# START:count
pat = re.compile("^.*?\\b([A-Za-z'-]+)\\b(.*)$")
concord = {}
for line in sys.stdin:
    m = pat.search(line)
    while m:
        word = m.group(1)
        concord[word] = concord.get(word, 0) + 1
        m = pat.search(m.group(2))
# END:count

# START:sort
entries = concord.items()
entries = [(count, word) for (word, count) in entries]
entries.sort()
entries.reverse()
for (count, word) in entries:
    print "%6d\t%s" % (count, word)
# END:sort
