import re

RE = ['',       'a',     'a.b',
      'a?b',    'a*b',   'a+b',
      'a\\.b',  'a\\+b', '.*ab']

data = ['',    'a',     'b',
        'Xab', 'aXb',   'abX',
        'ab',  'aXXXb', 'a.b']

# Tidy display
def show (s):
    if s is None:
        s = ""
    elif len(s) == 0:
        s = "''"
    print "%-6s" % s,

# Title
show(None)
for d in data:
    show(d)
print

# Results
for expr in RE:
    show(expr)
    for d in data:
        if re.search(expr, d):
            show("+")
        else:
            show("-")
    print
