/***
 * Excerpted from "Data Crunching"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/gwd for more book information.
***/
import java.sql.*;

class UpdatePerson {

    public static final String CHANGE = \
        "UPDATE Person" +
        " SET Person.FirstName = \"Charles\"" +
        " WHERE (Person.EmpId = 4004);";

    public static final String QUERY = \
        "SELECT Person.FirstName, Person.LastName FROM Person;";

    public static void main(String argv[]) {

        try {
            Class.forName("sqlite.JdbcDriver");                         // <label id="code.jdbc.driver"/>
            Connection con =                                            // <label id="code.jdbc.connect"/>
                DriverManager.getConnection("jdbc:sqlite:example",
                                            "admin", "pragmatic");

            Statement stmt = con.createStatement();			// <label id="code.jdbc.execstart"/>
            stmt.executeQuery(CHANGE);
            con.commit();

            ResultSet rs = stmt.executeQuery(QUERY);
            while (rs.next()) {
                String firstName = rs.getString(1);
                String lastName = rs.getString(2);
                System.out.println(lastName + ", " + firstName);
            }								// <label id="code.jdbc.execend"/>

            stmt.close();
            con.close();
        }

        catch (ClassNotFoundException ex) {				// <label id="code.jdbc.noclass"/>
            System.out.println(ex);
        }

        catch (SQLException ex) {					// <label id="code.jdbc.rollback"/>
            System.err.println(ex);
            con.rollback();
        }
    }
}
