-- Find people who cost more than the average per project.

CREATE VIEW ProjAveRate AS
  SELECT    Project.ProjId AS ProjId, AVG(Person.Rate) AS AveRate
  FROM      Person, Assigned, Project
  WHERE    (Person.EmpId = Assigned.EmpId)
  AND      (Project.ProjId = Assigned.ProjId)
  GROUP BY Assigned.ProjId;

SELECT    ProjAveRate.ProjId, Person.FirstName, Person.LastName, Person.Rate, ProjAveRate.AveRate
FROM      Person, Assigned, ProjAveRate
WHERE    (Person.EmpId = Assigned.EmpId)
  AND    (Assigned.ProjId = ProjAveRate.ProjId)
  AND    (Person.Rate < ProjAveRate.AveRate);

DROP VIEW ProjAveRate;
