import sys, os
from cgi import escape

HEADER = '''<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE chapter SYSTEM "../../local/xml/markup.dtd">
%s
<simpletable colspec="%s">'''

FOOTER = '''</simpletable>'''

if len(sys.argv) <= 1:
    print >> sys.stderr, "Check usage"

missing = ''
lines = None
sqlite, args = sys.argv[1], sys.argv[2:]
while args:
    arg, args = args[0], args[1:]
    if arg == "-m":
        missing = '<missing>Turn this into a figure!</missing>'
    elif arg == "-d":
        dbName, tableName, args = args[0], args[1], args[2:]
        cmd = '%s %s "select * from %s"' % (sqlite, dbName, tableName)
        input = os.popen(cmd, 'r')
        lines = input.readlines()
        input.close()
    elif arg == "-q":
        lines = sys.stdin.readlines()

if lines is None:
    print >> sys.stderr, "Need either -d or -q"
if not lines:
    lines = ["--EMPTY--"]

numCols = len(lines[0].split('|'))
colspec = ' '.join(['l'] * numCols)
print HEADER % (missing, colspec)
for line in lines:
    print '<row>'
    fields = line.rstrip().split('|')
    for f in fields:
        print '  <col><p>%s</p></col>' % escape(f)
    print '</row>'
print FOOTER
