import sys

def error(msg):
    print >> sys.stderr, msg
    sys.exit(1)

def readIni(inputName):
    input = open(inputName, 'r')
    result = []
    for line in input:
        first = line.find('#')
        if first >= 0:
            line = line[:first]
        line = line.strip()
        if (not line) or (line[0] == '#'):
            continue
        result.append(line)
    return result

# START:escape
def escape(s):
    return s.replace('&', '&amp;')\
           .replace('<', '&lt;')\
           .replace('>', '&gt;')\
           .replace("'", '&apos;')\
           .replace('"', '&quot;')
# END:escape

# START:process
def process(lines):
    result = ['<configure>']
    for line in lines:

        # Start of new section
        if line[0] == '[':

            # Close previous section
            result.append('</section>')

            # Start new section
            title = line[1:-1]
            result.append('<section title="%s">' % title)

        # Entry in current section
        else:
            key, value = line.split('=', 1)
            value = escape(value)
            result.append('  <entry key="%s">%s</entry>' % \
                          (key, value))

    # Done
    result.append('</configure>')
    return result
# END:process

for inputName in sys.argv[1:]:
    lines = readIni(inputName)
    settings = process(lines)
    for s in settings:
        print s
