import sys

# START:readPdb
def readPdb(inputName):
    input = open(inputName, 'r')
    result = []
    for line in input:
        if line[:4] == 'ATOM':
            fields = line.split()
            atom = [fields[2]] + fields[4:7]
            result.append(atom)
    input.close()
    return result
# END:readPdb

def normalizeSymbols(atoms):
    for record in atoms:
        record[0] = record[0].capitalize()

def translateName(inputName):
    return inputName[:-4] + '.vu3'

# START:write
Lookup = {
    'H'  : (1,  6, 0.2),
    'N'  : (1, 17, 0.5)
}

def writeVu3(outputName, atoms):
    output = open(outputName, 'w')
    for (symbol, X, Y, Z) in atoms:
        if symbol not in Lookup:
            print >> sys.stderr, 'Unknown atom "%s"' % symbol
            sys.exit(1)
        shape, color, radius = Lookup[symbol]
        print >> output, shape, color, radius, X, Y, Z
    output.close()
# END:write

for inputName in sys.argv[1:]:
    atoms = readPdb(inputName)
    normalizeSymbols(atoms)
    outputName = translateName(inputName)
    writeVu3(outputName, atoms)
