import sys
from xml.dom.minidom import parse

def concordance(node, result):
    seen = result.get(node.tagName, [])
    attrs = node.attributes
    for key in attrs.keys():
        if key not in seen:
            seen.append(key)
    result[node.tagName] = seen
    for child in node.childNodes:
        if child.nodeType is child.ELEMENT_NODE:
            concordance(child, result)
    return result

doc = parse(sys.stdin)
c = concordance(doc.documentElement, {})
for key in c:
    print key, ' '.join(c[key])
