/***
 * Excerpted from "Data Crunching"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/gwd for more book information.
***/
import java.util.Iterator;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.Text;

// START:class
public abstract class DomVisitor {

    public DomVisitor()
    {}

    public void visit(Element root) {
        _depth = 0;
        preRoot(root);
        atElement(root);
        recurse(root);
        postRoot(root);
    }

    protected void preRoot(Element root)
    {}

    protected void postRoot(Element root)
    {}

    protected void atElement(Element elt)
    {}

    protected void atText(Text text)
    {}
// END:class

// START:recurse
    protected void recurse(Element elt) {
        _depth += 1;
        Iterator ic = elt.getContent().iterator();
        while (ic.hasNext()) {
            Object node = ic.next();
            if (node instanceof Element) {
                Element child = (Element)node;
                atElement(child);
                recurse(child);
            }
            else if (node instanceof Text) {
                atText((Text)node);
            }
        }
        _depth -= 1;
    }
// END:recurse
// START:class

    protected int _depth;
}
// END:class
