import sys
from xml.sax import ContentHandler, parse, ErrorHandler

class ReportError(ErrorHandler):

    def fatalError(self, exception):
        self.printError("FATAL", exception)
    def error(self, exception):
        self.printError("ERROR", exception)
    def warning(self, exception):
        self.printError("WARNING", exception)
    def printError(self, level, exc):
        line = exc.getLineNumber()
        column = exc.getColumnNumber()
        loc = "(%d, %d)" % (line, column)
        msg = exc.getMessage()
        print "%s%s: %s" % (level, loc, msg)

if __name__ == "__main__":
    xmlHandler = ContentHandler()
    errHandler = ReportError()
    parse(sys.stdin, xmlHandler, errHandler)
