import sys
from xml.sax import parse, ContentHandler

class ShowAttr(ContentHandler):

    def __init__(self):
        self.table = {}

    def startElement(self, name, attrs):
        if name in self.table:
            seen = self.table[name]
        else:
            seen = []
        for a in attrs.keys():
            if a not in seen:
                seen.append(a)
        self.table[name] = seen

handler = ShowAttr()
parse(sys.stdin, handler)
elements = handler.table.keys()
elements.sort()
for e in elements:
    attrs = handler.table[e]
    if attrs:
        attrs.sort()
        print e, ":", ', '.join(attrs)
    else:
        print e
