/***
 * Excerpted from "Data Crunching"
 * We make no guarantees that this code is fit for any purpose. 
 * Visit http://www.pragmaticprogrammer.com/titles/gwd for more book information.
***/
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.SAXParserFactory;
import org.apache.xml.utils.DOMBuilder;
import org.apache.xpath.XPathAPI;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;

public class XPath {
    public static void main(String[] args) throws Exception {
        if (args.length == 0) {
            System.err.println("Usage: java XPath xpath0 [xpath1] [xpath2] ...");
            System.exit(-1);
        }
        XMLReader reader = SAXParserFactory.newInstance().newSAXParser().getXMLReader();
        Document document = DocumentBuilderFactory.newInstance().newDocumentBuilder().newDocument();
        reader.setContentHandler(new DOMBuilder(document));
        reader.parse(new InputSource(System.in));
        for (int i = 0; i < args.length; i++) {
            System.out.println("xpath: " + args[i]);
            print(XPathAPI.selectNodeList(document.getDocumentElement(), args[i]));
        }
    }

    static void print(NodeList list) {
        int length = list.getLength();
        for (int i = 0; i < length; i++) {
            if (0 < i) {
		System.out.println("--------");
	    }
            System.out.println(list.item(i));
        }
    }
}
