<!--
 ! Excerpted from "Data Crunching"
 ! We make no guarantees that this code is fit for any purpose. 
 ! Visit http://www.pragmaticprogrammer.com/titles/gwd for more book information.
-->
<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"  
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:template match="/personnel">
    <table>
      <xsl:apply-templates />
    </table>
  </xsl:template>
  
  <xsl:template match="person">
    <tr>
      <td>
        <xsl:value-of select="./surname"/>
      </td>
      <td>
        <xsl:apply-templates select="./rate"/> 
      </td>
    </tr>
  </xsl:template>

  <xsl:variable name="exchange-rate" 
                select="document('rates.xml')/*/rate" />

  <xsl:template match="rate">

    <xsl:variable name="currency">
      <xsl:choose>
        <xsl:when test="@currency">
          <xsl:value-of select="@currency"/>
        </xsl:when>
        <xsl:otherwise>USD</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="rate"> 
      <xsl:value-of select="$exchange-rate[@currency=$currency]/@rate" /> 
    </xsl:variable>

    <xsl:value-of select=". * $rate" />
  </xsl:template>
</xsl:stylesheet>
